diff -uNr nagios-plugins-1.4.11/lib/parse_ini.h nagios-plugins-1.4.12/lib/parse_ini.h
--- nagios-plugins-1.4.11/lib/parse_ini.h	1970-01-01 01:00:00.000000000 +0100
+++ nagios-plugins-1.4.12/lib/parse_ini.h	2008-03-31 07:31:14.000000000 +0200
@@ -0,0 +1,62 @@
+#ifndef _PARSE_INI_H_
+#define _PARSE_INI_H_
+
+/*
+ * parse_ini.h: routines for loading nagios-plugin defaults from ini
+ * configuration files.
+ */
+
+/* np_arg_list is a linked list of arguments passed between the ini
+ * parser and the argument parser to construct the final array */
+typedef struct np_arg_el {
+	char *arg;
+	struct np_arg_el *next;
+} np_arg_list;
+
+/* FIXME: This is in plugins/common.c. Should be eventually moved to lib/
+ * (although for this particular one  a configure settings should be ideal)
+ */
+#ifndef MAX_INPUT_BUFFER
+# define MAX_INPUT_BUFFER 8192
+#endif /* MAX_INPUT_BUFFER */
+
+/* Filenames (see below) */
+#ifndef NP_DEFAULT_INI_FILENAME1
+# define NP_DEFAULT_INI_FILENAME1 "plugins.ini"
+#endif /* NP_DEFAULT_INI_FILENAME1 */
+#ifndef NP_DEFAULT_INI_FILENAME2
+# define NP_DEFAULT_INI_FILENAME2 "nagios-plugins.ini"
+#endif /* NP_DEFAULT_INI_FILENAME2 */
+
+/* Config paths ending in nagios (search for NP_DEFAULT_INI_FILENAME1) */
+#ifndef NP_DEFAULT_INI_NAGIOS_PATH1
+# define NP_DEFAULT_INI_NAGIOS_PATH1 "/etc/nagios"
+#endif /* NP_DEFAULT_INI_NAGIOS_PATH1 */
+#ifndef NP_DEFAULT_INI_NAGIOS_PATH2
+# define NP_DEFAULT_INI_NAGIOS_PATH2 "/usr/local/nagios/etc"
+#endif /* NP_DEFAULT_INI_NAGIOS_PATH2 */
+#ifndef NP_DEFAULT_INI_NAGIOS_PATH3
+# define NP_DEFAULT_INI_NAGIOS_PATH3 "/usr/local/etc/nagios"
+#endif /* NP_DEFAULT_INI_NAGIOS_PATH3 */
+#ifndef NP_DEFAULT_INI_NAGIOS_PATH4
+# define NP_DEFAULT_INI_NAGIOS_PATH4 "/etc/opt/nagios"
+#endif /* NP_DEFAULT_INI_NAGIOS_PATH4 */
+
+/* Config paths not ending in nagios (search for NP_DEFAULT_INI_FILENAME2) */
+#ifndef NP_DEFAULT_INI_PATH1
+# define NP_DEFAULT_INI_PATH1 "/etc"
+#endif /* NP_DEFAULT_INI_PATH1 */
+#ifndef NP_DEFAULT_INI_PATH2
+# define NP_DEFAULT_INI_PATH2 "/usr/local/etc"
+#endif /* NP_DEFAULT_INI_PATH2 */
+#ifndef NP_DEFAULT_INI_PATH3
+# define NP_DEFAULT_INI_PATH3 "/etc/opt"
+#endif /* NP_DEFAULT_INI_PATH3 */
+
+/* np_load_defaults: load the default configuration (if present) for
+ * a plugin from the ini file
+ */
+np_arg_list* np_get_defaults(const char *locator, const char *default_section);
+
+#endif /* _PARSE_INI_H_ */
+
diff -uNr nagios-plugins-1.4.11/lib/tests/config-dos.ini nagios-plugins-1.4.12/lib/tests/config-dos.ini
--- nagios-plugins-1.4.11/lib/tests/config-dos.ini	1970-01-01 01:00:00.000000000 +0100
+++ nagios-plugins-1.4.12/lib/tests/config-dos.ini	2008-03-16 19:10:47.000000000 +0100
@@ -0,0 +1,24 @@
+# This config file is amended from perl's Config::Tiny's testcases
+
+# Line below is allowed in perl's Config::Tiny, but not in our parse_ini.c
+#root=something
+
+[section]
+one=two
+Foo=Bar
+this=Your Mother!
+blank=
+
+[Section Two]
+something else=blah
+ remove = whitespace   	
+
+[ /path/to/file.txt ]
+this=that
+
+[ section2]
+this=that
+
+[section3 ]
+this=that
+
diff -uNr nagios-plugins-1.4.11/lib/tests/config-opts.ini nagios-plugins-1.4.12/lib/tests/config-opts.ini
--- nagios-plugins-1.4.11/lib/tests/config-opts.ini	1970-01-01 01:00:00.000000000 +0100
+++ nagios-plugins-1.4.12/lib/tests/config-opts.ini	2008-03-24 08:02:28.000000000 +0100
@@ -0,0 +1,14 @@
+# This config file is for testing test_opts
+
+[sect1]
+one=two
+
+[check_disk]
+foo=Bar
+this=Your Mother!
+blank=
+
+[sect2]
+something else=oops
+this=that
+
diff -uNr nagios-plugins-1.4.11/lib/tests/config-tiny.ini nagios-plugins-1.4.12/lib/tests/config-tiny.ini
--- nagios-plugins-1.4.11/lib/tests/config-tiny.ini	1970-01-01 01:00:00.000000000 +0100
+++ nagios-plugins-1.4.12/lib/tests/config-tiny.ini	2007-02-07 15:46:50.000000000 +0100
@@ -0,0 +1,24 @@
+# This config file is amended from perl's Config::Tiny's testcases
+
+# Line below is allowed in perl's Config::Tiny, but not in our parse_ini.c
+#root=something
+
+[section]
+one=two
+Foo=Bar
+this=Your Mother!
+blank=
+
+[Section Two]
+something else=blah
+ remove = whitespace   	
+
+[ /path/to/file.txt ]
+this=that
+
+[ section2]
+this=that
+
+[section3 ]
+this=that
+
diff -uNr nagios-plugins-1.4.11/lib/tests/Makefile.am nagios-plugins-1.4.12/lib/tests/Makefile.am
--- nagios-plugins-1.4.11/lib/tests/Makefile.am	2007-12-12 02:27:48.000000000 +0100
+++ nagios-plugins-1.4.12/lib/tests/Makefile.am	2008-04-02 11:11:44.000000000 +0200
@@ -7,9 +7,11 @@
 
 INCLUDES = -I$(top_srcdir)/lib -I$(top_srcdir)/gl -I$(top_srcdir)/intl -I$(top_srcdir)/plugins
 
-EXTRA_PROGRAMS = test_utils test_disk test_tcp test_cmd test_base64
+EXTRA_PROGRAMS = test_utils test_disk test_tcp test_cmd test_base64 test_ini test_opts
 
-EXTRA_DIST = test_utils.t test_disk.t test_tcp.t test_cmd.t test_base64.t
+np_test_scripts = test_base64.t test_cmd.t test_disk.t test_ini.t test_opts.t test_tcp.t test_utils.t
+np_test_files = config-dos.ini config-opts.ini config-tiny.ini plugin.ini plugins.ini
+EXTRA_DIST = $(np_test_scripts) $(np_test_files)
 
 LIBS = @LIBINTL@
 
@@ -36,7 +38,17 @@
 test_base64_SOURCES = test_base64.c
 test_base64_CFLAGS = -g -I..
 test_base64_LDFLAGS = -L/usr/local/lib -ltap
-test_base64_LDADD = ../base64.o 
+test_base64_LDADD = $(top_srcdir)/gl/base64.o 
+
+test_ini_SOURCES = test_ini.c
+test_ini_CFLAGS = -g -I..
+test_ini_LDFLAGS = -L/usr/local/lib -ltap
+test_ini_LDADD = ../utils_base.o ../parse_ini.o
+
+test_opts_SOURCES = test_opts.c
+test_opts_CFLAGS = -g -I..
+test_opts_LDFLAGS = -L/usr/local/lib -ltap
+test_opts_LDADD = ../utils_base.o ../parse_ini.o ../extra_opts.o
 
 test: ${noinst_PROGRAMS}
 	perl -MTest::Harness -e '$$Test::Harness::switches=""; runtests(map {$$_ .= ".t"} @ARGV)' $(EXTRA_PROGRAMS)
diff -uNr nagios-plugins-1.4.11/lib/tests/plugin.ini nagios-plugins-1.4.12/lib/tests/plugin.ini
--- nagios-plugins-1.4.11/lib/tests/plugin.ini	1970-01-01 01:00:00.000000000 +0100
+++ nagios-plugins-1.4.12/lib/tests/plugin.ini	2008-03-16 19:10:47.000000000 +0100
@@ -0,0 +1,21 @@
+
+[check_mysql]
+username=operator
+password=secret		# Remember to change later
+
+[section_twice]
+foo=bar
+
+[check_mysql2]
+u=admin
+p=secret
+
+[section_twice]
+bar=foo
+
+[check space_and_flags]
+foo=bar
+a=
+b=
+bar=
+
diff -uNr nagios-plugins-1.4.11/lib/tests/plugins.ini nagios-plugins-1.4.12/lib/tests/plugins.ini
--- nagios-plugins-1.4.11/lib/tests/plugins.ini	1970-01-01 01:00:00.000000000 +0100
+++ nagios-plugins-1.4.12/lib/tests/plugins.ini	2008-03-26 10:46:27.000000000 +0100
@@ -0,0 +1,7 @@
+
+[check_disk]
+foo=bar
+
+[section1]
+foobar=baz
+
diff -uNr nagios-plugins-1.4.11/lib/tests/test_base64.c nagios-plugins-1.4.12/lib/tests/test_base64.c
--- nagios-plugins-1.4.11/lib/tests/test_base64.c	2007-11-10 00:24:45.000000000 +0100
+++ nagios-plugins-1.4.12/lib/tests/test_base64.c	2008-02-13 05:07:39.000000000 +0100
@@ -1,25 +1,24 @@
-/******************************************************************************
-
- This program is free software; you can redistribute it and/or modify
- it under the terms of the GNU General Public License as published by
- the Free Software Foundation; either version 2 of the License, or
- (at your option) any later version.
-
- This program is distributed in the hope that it will be useful,
- but WITHOUT ANY WARRANTY; without even the implied warranty of
- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- GNU General Public License for more details.
-
- You should have received a copy of the GNU General Public License
- along with this program; if not, write to the Free Software
- Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
-
- $Id: test_base64.c 1819 2007-11-09 23:24:45Z dermoth $
- 
-******************************************************************************/
+/*****************************************************************************
+* 
+* This program is free software: you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation, either version 3 of the License, or
+* (at your option) any later version.
+* 
+* This program is distributed in the hope that it will be useful,
+* but WITHOUT ANY WARRANTY; without even the implied warranty of
+* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+* GNU General Public License for more details.
+* 
+* You should have received a copy of the GNU General Public License
+* along with this program.  If not, see <http://www.gnu.org/licenses/>.
+* 
+* $Id: test_base64.c 1927 2008-02-13 04:07:39Z dermoth $
+* 
+*****************************************************************************/
 
 #include "common.h"
-#include "base64.h"
+#include "gl/base64.h"
 #include "tap.h"
 
 int
@@ -249,7 +248,7 @@
 	0x2b,0x00,0x1f,0x0c,0x28,0x59,0x0a,0x16,0x49,0x5a,0x5c,0x64,0x65,0x4b,0x11,0x29,
 	0x15,0x36,0x5a,0x65,0x19,0x4f,0x60,0x23,0x3a,0x3a,0x13,0x25,0x02,0x78,0x4c,0x54
 	};
-  char b64_known[1368] = {
+  char b64_known[1369] = {
 	0x43,0x7a,0x42,0x45,0x59,0x6e,0x77,0x69,0x48,0x77,0x30,0x46,0x5a,0x79,0x77,0x71,
 	0x4f,0x53,0x46,0x47,0x43,0x46,0x42,0x6d,0x4e,0x44,0x63,0x4c,0x52,0x55,0x73,0x34,
 	0x4d,0x67,0x5a,0x36,0x50,0x6e,0x38,0x4d,0x51,0x42,0x68,0x72,0x4c,0x57,0x42,0x4d,
@@ -335,13 +334,13 @@
 	0x48,0x33,0x41,0x41,0x4c,0x6d,0x59,0x55,0x50,0x48,0x38,0x72,0x41,0x42,0x38,0x4d,
 	0x4b,0x46,0x6b,0x4b,0x46,0x6b,0x6c,0x61,0x58,0x47,0x52,0x6c,0x53,0x78,0x45,0x70,
 	0x46,0x54,0x5a,0x61,0x5a,0x52,0x6c,0x50,0x59,0x43,0x4d,0x36,0x4f,0x68,0x4d,0x6c,
-	0x41,0x6e,0x68,0x4d,0x56,0x41,0x3d,0x3d
+	0x41,0x6e,0x68,0x4d,0x56,0x41,0x3d,0x3d,0x00
 	};
 	char *b64_test;
 
 	plan_tests(1);
 
-	b64_test = base64 (random, 1024);
+	base64_encode_alloc (random, 1024, &b64_test);
 
 	ok(strcmp(b64_known, b64_test) == 0,
 	   "Test matching a base64 encoded 1024 bytes random string");
diff -uNr nagios-plugins-1.4.11/lib/tests/test_cmd.c nagios-plugins-1.4.12/lib/tests/test_cmd.c
--- nagios-plugins-1.4.11/lib/tests/test_cmd.c	2007-12-11 13:05:16.000000000 +0100
+++ nagios-plugins-1.4.12/lib/tests/test_cmd.c	2008-01-30 10:38:37.000000000 +0100
@@ -1,22 +1,21 @@
-/******************************************************************************
-
- This program is free software; you can redistribute it and/or modify
- it under the terms of the GNU General Public License as published by
- the Free Software Foundation; either version 2 of the License, or
- (at your option) any later version.
-
- This program is distributed in the hope that it will be useful,
- but WITHOUT ANY WARRANTY; without even the implied warranty of
- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- GNU General Public License for more details.
-
- You should have received a copy of the GNU General Public License
- along with this program; if not, write to the Free Software
- Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
-
- $Id: test_cmd.c 1732 2007-06-03 15:58:22Z psychotrahe $
- 
-******************************************************************************/
+/*****************************************************************************
+* 
+* This program is free software: you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation, either version 3 of the License, or
+* (at your option) any later version.
+* 
+* This program is distributed in the hope that it will be useful,
+* but WITHOUT ANY WARRANTY; without even the implied warranty of
+* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+* GNU General Public License for more details.
+* 
+* You should have received a copy of the GNU General Public License
+* along with this program.  If not, see <http://www.gnu.org/licenses/>.
+* 
+* $Id$
+* 
+*****************************************************************************/
 
 #include "common.h"
 #include "utils_cmd.h"
@@ -51,7 +50,7 @@
 	int c;
 	int result = UNSET;
 
-	plan_tests(50);
+	plan_tests(51);
 
 	diag ("Running plain echo command, set one");
 
@@ -202,7 +201,17 @@
 	ok (chld_err.lines == 1,
 			"...but does give an error line");
 	ok (strstr(chld_err.line[0],"non-existant-file") != NULL, "And missing filename is in error message");
-	ok (result == 127, "Get return code 127 from /bin/sh");
+	ok (result != 0, "Get non-zero return code from /bin/sh");
+
+
+	/* ensure everything is empty again */
+	result = UNSET;
+
+	command = (char *)malloc(COMMAND_LINE);
+  strcpy(command, "/bin/sh -c 'exit 7'");
+  result = cmd_run (command, NULL, NULL, 0);
+
+  ok (result == 7, "Get return code 7 from /bin/sh");
 
 
 	/* ensure everything is empty again */
diff -uNr nagios-plugins-1.4.11/lib/tests/test_disk.c nagios-plugins-1.4.12/lib/tests/test_disk.c
--- nagios-plugins-1.4.11/lib/tests/test_disk.c	2007-09-22 19:40:35.000000000 +0200
+++ nagios-plugins-1.4.12/lib/tests/test_disk.c	2008-01-30 10:38:37.000000000 +0100
@@ -1,22 +1,21 @@
-/******************************************************************************
-
- This program is free software; you can redistribute it and/or modify
- it under the terms of the GNU General Public License as published by
- the Free Software Foundation; either version 2 of the License, or
- (at your option) any later version.
-
- This program is distributed in the hope that it will be useful,
- but WITHOUT ANY WARRANTY; without even the implied warranty of
- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- GNU General Public License for more details.
-
- You should have received a copy of the GNU General Public License
- along with this program; if not, write to the Free Software
- Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
-
- $Id: test_disk.c 1786 2007-09-22 17:40:35Z psychotrahe $
- 
-******************************************************************************/
+/*****************************************************************************
+* 
+* This program is free software: you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation, either version 3 of the License, or
+* (at your option) any later version.
+* 
+* This program is distributed in the hope that it will be useful,
+* but WITHOUT ANY WARRANTY; without even the implied warranty of
+* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+* GNU General Public License for more details.
+* 
+* You should have received a copy of the GNU General Public License
+* along with this program.  If not, see <http://www.gnu.org/licenses/>.
+* 
+* $Id: test_disk.c 1914 2008-01-30 09:38:37Z dermoth $
+* 
+*****************************************************************************/
 
 #include "common.h"
 #include "utils_disk.h"
diff -uNr nagios-plugins-1.4.11/lib/tests/test_ini.c nagios-plugins-1.4.12/lib/tests/test_ini.c
--- nagios-plugins-1.4.11/lib/tests/test_ini.c	1970-01-01 01:00:00.000000000 +0100
+++ nagios-plugins-1.4.12/lib/tests/test_ini.c	2008-04-04 12:11:22.000000000 +0200
@@ -0,0 +1,114 @@
+/*****************************************************************************
+* 
+* This program is free software: you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation, either version 3 of the License, or
+* (at your option) any later version.
+* 
+* This program is distributed in the hope that it will be useful,
+* but WITHOUT ANY WARRANTY; without even the implied warranty of
+* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+* GNU General Public License for more details.
+* 
+* You should have received a copy of the GNU General Public License
+* along with this program.  If not, see <http://www.gnu.org/licenses/>.
+* 
+* $Id: test_ini.c 1976 2008-04-04 10:11:22Z dermoth $
+* 
+*****************************************************************************/
+
+#include "common.h"
+#include "utils_base.h"
+#include "parse_ini.h"
+
+#include "tap.h"
+
+void my_free(char *string) {
+	if (string != NULL) {
+		printf("string:\n\t|%s|\n", string);
+		free(string);
+	}
+}
+
+char*
+list2str(np_arg_list *optlst)
+{
+	char *optstr=NULL;
+	np_arg_list *optltmp;
+
+	/* Put everything as a space-separated string */
+	asprintf(&optstr, "");
+	while (optlst) {
+		asprintf(&optstr, "%s%s ", optstr, optlst->arg);
+		optltmp=optlst;
+		optlst=optlst->next;
+		free(optltmp);
+	}
+	/* Strip last whitespace */
+	if (strlen(optstr)>1) optstr[strlen(optstr)-1]='\0';
+
+	return optstr;
+}
+
+int
+main (int argc, char **argv)
+{
+	char *optstr=NULL;
+
+	plan_tests(11);
+
+	optstr=list2str(np_get_defaults("section@./config-tiny.ini", "check_disk"));
+	ok( !strcmp(optstr, "--one=two --Foo=Bar --this=Your Mother! --blank"), "config-tiny.ini's section as expected");
+	my_free(optstr);
+
+	optstr=list2str(np_get_defaults("@./config-tiny.ini", "section"));
+	ok( !strcmp(optstr, "--one=two --Foo=Bar --this=Your Mother! --blank"), "Used default section name, without specific");
+	my_free(optstr);
+
+	/*
+	 * This check is expected to die - It's commented so we can eventually put
+	 * it in a separate file for testing the return value
+	 */
+	/* optstr=list2str(np_get_defaults("section_unknown@./config-tiny.ini", "section"));
+	ok( 0, "die if section isn't found");
+	my_free(optstr); */
+
+	optstr=list2str(np_get_defaults("Section Two@./config-tiny.ini", "check_disk"));
+	ok( !strcmp(optstr, "--something else=blah --remove=whitespace"), "config-tiny.ini's Section Two as expected");
+	my_free(optstr);
+
+	optstr=list2str(np_get_defaults("/path/to/file.txt@./config-tiny.ini", "check_disk"));
+	ok( !strcmp(optstr, "--this=that"), "config-tiny.ini's filename as section name");
+	my_free(optstr);
+
+	optstr=list2str(np_get_defaults("section2@./config-tiny.ini", "check_disk"));
+	ok( !strcmp(optstr, "--this=that"), "config-tiny.ini's section2 with whitespace before section name");
+	my_free(optstr);
+
+	optstr=list2str(np_get_defaults("section3@./config-tiny.ini", "check_disk"));
+	ok( !strcmp(optstr, "--this=that"), "config-tiny.ini's section3 with whitespace after section name");
+	my_free(optstr);
+
+	optstr=list2str(np_get_defaults("check_mysql@./plugin.ini", "check_disk"));
+	ok( !strcmp(optstr, "--username=operator --password=secret"), "plugin.ini's check_mysql as expected");
+	my_free(optstr);
+
+	optstr=list2str(np_get_defaults("check_mysql2@./plugin.ini", "check_disk"));
+	ok( !strcmp(optstr, "-u=admin -p=secret"), "plugin.ini's check_mysql2 as expected");
+	my_free(optstr);
+
+	optstr=list2str(np_get_defaults("check space_and_flags@./plugin.ini", "check_disk"));
+	ok( !strcmp(optstr, "--foo=bar -a -b --bar"), "plugin.ini space in stanza and flag arguments");
+	my_free(optstr);
+
+	optstr=list2str(np_get_defaults("Section Two@./config-dos.ini", "check_disk"));
+	ok( !strcmp(optstr, "--something else=blah --remove=whitespace"), "config-dos.ini's Section Two as expected");
+	my_free(optstr);
+
+	optstr=list2str(np_get_defaults("section_twice@./plugin.ini", "check_disk"));
+	ok( !strcmp(optstr, "--foo=bar --bar=foo"), "plugin.ini's section_twice defined twice in the file");
+	my_free(optstr);
+
+	return exit_status();
+}
+
diff -uNr nagios-plugins-1.4.11/lib/tests/test_ini.t nagios-plugins-1.4.12/lib/tests/test_ini.t
--- nagios-plugins-1.4.11/lib/tests/test_ini.t	1970-01-01 01:00:00.000000000 +0100
+++ nagios-plugins-1.4.12/lib/tests/test_ini.t	2008-04-02 11:11:44.000000000 +0200
@@ -0,0 +1,6 @@
+#!/usr/bin/perl
+use Test::More;
+if (! -e "./test_ini") {
+	plan skip_all => "./test_ini not compiled - please install tap library and/or enable parse-ini to test";
+}
+exec "./test_ini";
diff -uNr nagios-plugins-1.4.11/lib/tests/test_opts.c nagios-plugins-1.4.12/lib/tests/test_opts.c
--- nagios-plugins-1.4.11/lib/tests/test_opts.c	1970-01-01 01:00:00.000000000 +0100
+++ nagios-plugins-1.4.12/lib/tests/test_opts.c	2008-04-04 12:11:22.000000000 +0200
@@ -0,0 +1,278 @@
+/*****************************************************************************
+* 
+* This program is free software: you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation, either version 3 of the License, or
+* (at your option) any later version.
+* 
+* This program is distributed in the hope that it will be useful,
+* but WITHOUT ANY WARRANTY; without even the implied warranty of
+* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+* GNU General Public License for more details.
+* 
+* You should have received a copy of the GNU General Public License
+* along with this program.  If not, see <http://www.gnu.org/licenses/>.
+* 
+* $Id: test_ini.c 1951 2008-03-16 18:10:47Z dermoth $
+* 
+*****************************************************************************/
+
+#include "common.h"
+#include "utils_base.h"
+#include "extra_opts.h"
+
+#include "tap.h"
+
+void my_free(int *argc, char **argv) {
+	int i;
+	printf ("    Arg(%i): ", *argc);
+	for (i=1; i<*argc; i++) printf ("'%s' ", argv[i]);
+	printf ("\n");
+	free(argv);
+	*argc=0;
+}
+
+int array_diff(int i1, char **a1, int i2, char **a2) {
+	int i;
+
+	if (i1 != i2) {
+		printf("    Argument count doesn't match!\n");
+		return 0;
+	}
+	for (i=0; i<=i1; i++) {
+		if (a1[i]==NULL && a2[i]==NULL) continue;
+		if (a1[i]==NULL || a2[i]==NULL) {
+			printf("    Argument # %i null in one array!\n", i);
+			return 0;
+		}
+		if (strcmp(a1[i], a2[i])) {
+			printf("    Argument # %i doesn't match!\n", i);
+			return 0;
+		}
+	}
+	return 1;
+}
+
+int
+main (int argc, char **argv)
+{
+	char **argv_test=NULL, **argv_known=NULL;
+	int i, argc_test;
+
+	plan_tests(9);
+
+	argv_test=(char **)malloc(2*sizeof(char **));
+	argv_test[0] = "prog_name";
+	argv_test[1] = NULL;
+	argc_test=1;
+	argv_known=(char **)realloc(argv_known, 2*sizeof(char **));
+	argv_known[0] = "prog_name";
+	argv_known[1] = NULL;
+	argv_test=np_extra_opts(&argc_test, argv_test, "check_disk");
+	ok(array_diff(argc_test, argv_test, 1, argv_known), "No opts, returns correct argv/argc");
+	my_free(&argc_test, argv_test);
+
+	argv_test=(char **)malloc(6*sizeof(char **));
+	argv_test[0] = "prog_name";
+	argv_test[1] = "arg1";
+	argv_test[2] = "--arg2=val1";
+	argv_test[3] = "--arg3";
+	argv_test[4] = "val2";
+	argv_test[5] = NULL;
+	argc_test=5;
+	argv_known=(char **)realloc(argv_known, 6*sizeof(char **));
+	argv_known[0] = "prog_name";
+	argv_known[1] = "arg1";
+	argv_known[2] = "--arg2=val1";
+	argv_known[3] = "--arg3";
+	argv_known[4] = "val2";
+	argv_known[5] = NULL;
+	argv_test=np_extra_opts(&argc_test, argv_test, "check_disk");
+	ok(array_diff(argc_test, argv_test, 5, argv_known), "No extra opts, verbatim copy of argv");
+	my_free(&argc_test,argv_test);
+
+	argv_test=(char **)malloc(3*sizeof(char **));
+	argv_test[0] = "prog_name";
+	argv_test[1] = "--extra-opts=@./config-opts.ini";
+	argv_test[2] = NULL;
+	argc_test=2;
+	argv_known=(char **)realloc(argv_known, 5*sizeof(char **));
+	argv_known[0] = "prog_name";
+	argv_known[1] = "--foo=Bar";
+	argv_known[2] = "--this=Your Mother!";
+	argv_known[3] = "--blank";
+	argv_known[4] = NULL;
+	argv_test=np_extra_opts(&argc_test, argv_test, "check_disk");
+	ok(array_diff(argc_test, argv_test, 4, argv_known), "Only extra opts using default section");
+	my_free(&argc_test,argv_test);
+
+	argv_test=(char **)malloc(5*sizeof(char **));
+	argv_test[0] = "prog_name";
+	argv_test[1] = "--extra-opts=sect1@./config-opts.ini";
+	argv_test[2] = "--extra-opts";
+	argv_test[3] = "sect2@./config-opts.ini";
+	argv_test[4] = NULL;
+	argc_test=4;
+	argv_known=(char **)realloc(argv_known, 5*sizeof(char **));
+	argv_known[0] = "prog_name";
+	argv_known[1] = "--one=two";
+	argv_known[2] = "--something else=oops";
+	argv_known[3] = "--this=that";
+	argv_known[4] = NULL;
+	argv_test=np_extra_opts(&argc_test, argv_test, "check_disk");
+	ok(array_diff(argc_test, argv_test, 4, argv_known), "Only extra opts specified twice");
+	my_free(&argc_test,argv_test);
+
+	argv_test=(char **)malloc(7*sizeof(char **));
+	argv_test[0] = "prog_name";
+	argv_test[1] = "--arg1=val1";
+	argv_test[2] = "--extra-opts=@./config-opts.ini";
+	argv_test[3] = "--extra-opts";
+	argv_test[4] = "sect1@./config-opts.ini";
+	argv_test[5] = "--arg2";
+	argv_test[6] = NULL;
+	argc_test=6;
+	argv_known=(char **)realloc(argv_known, 8*sizeof(char **));
+	argv_known[0] = "prog_name";
+	argv_known[1] = "--foo=Bar";
+	argv_known[2] = "--this=Your Mother!";
+	argv_known[3] = "--blank";
+	argv_known[4] = "--one=two";
+	argv_known[5] = "--arg1=val1";
+	argv_known[6] = "--arg2";
+	argv_known[7] = NULL;
+	argv_test=np_extra_opts(&argc_test, argv_test, "check_disk");
+	ok(array_diff(argc_test, argv_test, 7, argv_known), "twice extra opts using two sections");
+	my_free(&argc_test,argv_test);
+
+	/* Next three checks dre expected to die. They are commented out as they
+	 * could possibly go in a sepatare test checked for return value.
+	 */
+	/* argv_test=(char **)malloc(6*sizeof(char **));
+	argv_test[0] = "prog_name";
+	argv_test[1] = "arg1";
+	argv_test[2] = "--extra-opts=missing@./config-opts.ini";
+	argv_test[3] = "--arg3";
+	argv_test[4] = "val2";
+	argv_test[5] = NULL;
+	argc_test=5;
+	argv_known=(char **)realloc(argv_known, 5*sizeof(char **));
+	argv_known[0] = "prog_name";
+	argv_known[1] = "arg1";
+	argv_known[2] = "--arg3";
+	argv_known[3] = "val2";
+	argv_known[4] = NULL;
+	argv_test=np_extra_opts(&argc_test, argv_test, "check_missing");
+	ok(array_diff(argc_test, argv_test, 4, argv_known), "Missing section 1");
+	my_free(&argc_test,argv_test); */
+
+	/* argv_test=(char **)malloc(7*sizeof(char **));
+	argv_test[0] = "prog_name";
+	argv_test[1] = "arg1";
+	argv_test[2] = "--extra-opts";
+	argv_test[3] = "missing@./config-opts.ini";
+	argv_test[4] = "--arg3";
+	argv_test[5] = "val2";
+	argv_test[6] = NULL;
+	argc_test=6;
+	argv_known=(char **)realloc(argv_known, 5*sizeof(char **));
+	argv_known[0] = "prog_name";
+	argv_known[1] = "arg1";
+	argv_known[2] = "--arg3";
+	argv_known[3] = "val2";
+	argv_known[4] = NULL;
+	argv_test=np_extra_opts(&argc_test, argv_test, "check_missing");
+	ok(array_diff(argc_test, argv_test, 4, argv_known), "Missing section 2");
+	my_free(&argc_test,argv_test); */
+
+	/* argv_test=(char **)malloc(6*sizeof(char **));
+	argv_test[0] = "prog_name";
+	argv_test[1] = "arg1";
+	argv_test[2] = "--extra-opts";
+	argv_test[3] = "--arg3";
+	argv_test[4] = "val2";
+	argv_test[5] = NULL;
+	argc_test=5;
+	argv_known=(char **)realloc(argv_known, 5*sizeof(char **));
+	argv_known[0] = "prog_name";
+	argv_known[1] = "arg1";
+	argv_known[2] = "--arg3";
+	argv_known[3] = "val2";
+	argv_known[4] = NULL;
+	argv_test=np_extra_opts(&argc_test, argv_test, "check_missing");
+	ok(array_diff(argc_test, argv_test, 4, argv_known), "Missing section 3");
+	my_free(&argc_test,argv_test); */
+
+	setenv("NAGIOS_CONFIG_PATH", ".", 1);
+	argv_test=(char **)malloc(6*sizeof(char **));
+	argv_test[0] = "prog_name";
+	argv_test[1] = "arg1";
+	argv_test[2] = "--extra-opts";
+	argv_test[3] = "--arg3";
+	argv_test[4] = "val2";
+	argv_test[5] = NULL;
+	argc_test=5;
+	argv_known=(char **)realloc(argv_known, 6*sizeof(char **));
+	argv_known[0] = "prog_name";
+	argv_known[1] = "--foo=bar";
+	argv_known[2] = "arg1";
+	argv_known[3] = "--arg3";
+	argv_known[4] = "val2";
+	argv_known[5] = NULL;
+	argv_test=np_extra_opts(&argc_test, argv_test, "check_disk");
+	ok(array_diff(argc_test, argv_test, 5, argv_known), "Default section 1");
+
+	argv_test=(char **)malloc(3*sizeof(char **));
+	argv_test[0] = "prog_name";
+	argv_test[1] = "--extra-opts";
+	argv_test[2] = NULL;
+	argc_test=2;
+	argv_known=(char **)realloc(argv_known, 3*sizeof(char **));
+	argv_known[0] = "prog_name";
+	argv_known[1] = "--foo=bar";
+	argv_known[2] = NULL;
+	argv_test=np_extra_opts(&argc_test, argv_test, "check_disk");
+	ok(array_diff(argc_test, argv_test, 2, argv_known), "Default section 2");
+	my_free(&argc_test,argv_test);
+
+	argv_test=(char **)malloc(6*sizeof(char **));
+	argv_test[0] = "prog_name";
+	argv_test[1] = "arg1";
+	argv_test[2] = "--extra-opts=section1";
+	argv_test[3] = "--arg3";
+	argv_test[4] = "val2";
+	argv_test[5] = NULL;
+	argc_test=5;
+	argv_known=(char **)realloc(argv_known, 6*sizeof(char **));
+	argv_known[0] = "prog_name";
+	argv_known[1] = "--foobar=baz";
+	argv_known[2] = "arg1";
+	argv_known[3] = "--arg3";
+	argv_known[4] = "val2";
+	argv_known[5] = NULL;
+	argv_test=np_extra_opts(&argc_test, argv_test, "check_disk");
+	ok(array_diff(argc_test, argv_test, 5, argv_known), "Default section 3");
+	my_free(&argc_test,argv_test);
+
+	argv_test=(char **)malloc(6*sizeof(char **));
+	argv_test[0] = "prog_name";
+	argv_test[1] = "arg1";
+	argv_test[2] = "--extra-opts";
+	argv_test[3] = "-arg3";
+	argv_test[4] = "val2";
+	argv_test[5] = NULL;
+	argc_test=5;
+	argv_known=(char **)realloc(argv_known, 6*sizeof(char **));
+	argv_known[0] = "prog_name";
+	argv_known[1] = "--foo=bar";
+	argv_known[2] = "arg1";
+	argv_known[3] = "-arg3";
+	argv_known[4] = "val2";
+	argv_known[5] = NULL;
+	argv_test=np_extra_opts(&argc_test, argv_test, "check_disk");
+	ok(array_diff(argc_test, argv_test, 5, argv_known), "Default section 4");
+	my_free(&argc_test,argv_test);
+
+	return exit_status();
+}
+
diff -uNr nagios-plugins-1.4.11/lib/tests/test_opts.t nagios-plugins-1.4.12/lib/tests/test_opts.t
--- nagios-plugins-1.4.11/lib/tests/test_opts.t	1970-01-01 01:00:00.000000000 +0100
+++ nagios-plugins-1.4.12/lib/tests/test_opts.t	2008-04-02 11:11:44.000000000 +0200
@@ -0,0 +1,6 @@
+#!/usr/bin/perl
+use Test::More;
+if (! -e "./test_opts") {
+	plan skip_all => "./test_opts not compiled - please install tap library and/or enable parse-ini to test";
+}
+exec "./test_opts";
diff -uNr nagios-plugins-1.4.11/lib/tests/test_tcp.c nagios-plugins-1.4.12/lib/tests/test_tcp.c
--- nagios-plugins-1.4.11/lib/tests/test_tcp.c	2007-06-03 17:58:22.000000000 +0200
+++ nagios-plugins-1.4.12/lib/tests/test_tcp.c	2008-01-30 10:38:37.000000000 +0100
@@ -1,22 +1,21 @@
-/******************************************************************************
-
- This program is free software; you can redistribute it and/or modify
- it under the terms of the GNU General Public License as published by
- the Free Software Foundation; either version 2 of the License, or
- (at your option) any later version.
-
- This program is distributed in the hope that it will be useful,
- but WITHOUT ANY WARRANTY; without even the implied warranty of
- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- GNU General Public License for more details.
-
- You should have received a copy of the GNU General Public License
- along with this program; if not, write to the Free Software
- Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
-
- $Id: test_tcp.c 1732 2007-06-03 15:58:22Z psychotrahe $
- 
-******************************************************************************/
+/*****************************************************************************
+* 
+* This program is free software: you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation, either version 3 of the License, or
+* (at your option) any later version.
+* 
+* This program is distributed in the hope that it will be useful,
+* but WITHOUT ANY WARRANTY; without even the implied warranty of
+* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+* GNU General Public License for more details.
+* 
+* You should have received a copy of the GNU General Public License
+* along with this program.  If not, see <http://www.gnu.org/licenses/>.
+* 
+* $Id: test_tcp.c 1914 2008-01-30 09:38:37Z dermoth $
+* 
+*****************************************************************************/
 
 #include "common.h"
 #include "utils_tcp.h"
